import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
/**
 * Write a description of class Player_2 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player_2 extends Bomberman
{
    int delayTimer = 0;
    int numBombs = 1;
    int maxBombs = 1;
    int lives = 3;
    int counter = 0;
    boolean blink = false;
    int speed = 1;
    int delay = 0;
    int power = 1;
    /**
     * The default constructor for PlayerTwo
     */
    public Player_2()
    {
    }
    /**
     * Checks if player can move, reduces the delay timer, and calls all methods for player2
     */
    public void act() 
    {
        Block blk=(Block)getOneIntersectingObject(Block.class);
        Wall wll=(Wall)getOneIntersectingObject(Wall.class);
        if(blk!=null || wll!=null){
            setLocation(getX(),getY());
        }
        else{
            if(Greenfoot.isKeyDown("up")){
                if(getY()==816){
                    setLocation(getX(),getY());
                }
                else{
                    setLocation(getX(), getY() - speed);
                    release_up();
                }
            }
            if(Greenfoot.isKeyDown("left")){
                if(getX()==0){
                    setLocation(getX(),getY());
                }
                else{
                    setLocation(getX() - speed, getY());
                    release_left();
                }
            }
            if(Greenfoot.isKeyDown("right")){
                if(getX()==816){
                    setLocation(getX(),getY());
                }
                else{
                    setLocation(getX() + speed, getY());
                    release_right();
                }
            }
            if(Greenfoot.isKeyDown("down")){
                if(getY()==816){
                    setLocation(getX(),getY());
                }
                else{
                    setLocation(getX(), getY() + speed);
                    release_down();
                }
            }
        }
        if (delayTimer<100){
                delayTimer = delayTimer + 1;
            }
            else{
                if (delayTimer>=100){
                    if(numBombs<maxBombs){
                        numBombs = numBombs + 1;
                    }
                    delayTimer=0;
                }
            }
        upgrade();
        placeBomb();
        blink();
        sendUserData();
    }
    /**
     * If player is intersecting wall after movement, back him out
     */
    public void release_up()
    {
        Block blk=(Block)getOneIntersectingObject(Block.class);
        Wall wll=(Wall)getOneIntersectingObject(Wall.class);
        if(blk!=null || wll!=null){
            setLocation(getX(), getY() + speed);
        }
    }
    public void release_down()
    {
        Block blk=(Block)getOneIntersectingObject(Block.class);
        Wall wll=(Wall)getOneIntersectingObject(Wall.class);
        if(blk!=null || wll!=null){
            setLocation(getX(), getY() - speed);
        }
    }
    public void release_left()
    {
        Block blk=(Block)getOneIntersectingObject(Block.class);
        Wall wll=(Wall)getOneIntersectingObject(Wall.class);
        if(blk!=null || wll!=null){
            setLocation(getX() + speed, getY());
        }
    }
    public void release_right()
    {
        Block blk=(Block)getOneIntersectingObject(Block.class);
        Wall wll=(Wall)getOneIntersectingObject(Wall.class);
        if(blk!=null || wll!=null){
            setLocation(getX() - speed, getY());
        }
    }
    /**
     * If the delay timer is zero and the player is pressing space, place the bomb
     */
    public void placeBomb()
    {
        if(delay>0){
            delay--;
        }
        if(Greenfoot.isKeyDown("enter") && delay==0){
            if(numBombs>=1){
                int x = 0;
                int y = 0;
                for(int i=0; i<17; i++){
                    if((getX()-(24+(48*i))>=(-24)) && (getX()-(24+(48*i))<=24)){
                        x = (24+(48*i));
                    }
                }
                for(int i=0; i<17; i++){
                    if((getY()-(24+(48*i))>=(-24)) && (getY()-(24+(48*i))<=24)){
                        y = (24+(48*i));
                    }
                }
                getWorld().addObject(new Bomb_2(power), x, y);
                numBombs = numBombs - 1;
            }
            delay = 15;
        }
    }
    /**
     * Makes the player blink when hit
     */
    public void blink()
    {
        if(blink == true){
             if (counter == 10  || counter == 20 || counter == 30 || counter == 40 || counter == 50 || counter == 60 || counter == 70 || counter == 80 || counter == 90)
             {
                 getImage().setTransparency(255);
             }
             else if (counter == 5 || counter == 15 || counter == 25 || counter == 35 || counter == 45 || counter == 55 || counter == 65 || counter == 75 || counter == 85 || counter == 95)
             {
                 getImage().setTransparency(0);
             }
             if (counter == 100) 
             {
                 getImage().setTransparency(255);
                 counter = 0;
                 blink = false;
             }
             counter++;
        }
    }
    /**
     * Lets player pick up powerup and increase stats
     */
    public void upgrade()
    {
        Actor Speed  = getOneObjectAtOffset(0,0,Speed.class);
        if(Speed!=null){
            if(speed<5){
                speed++;
            }
            getWorld().removeObject(Speed);
        }
        Actor NumBombs  = getOneObjectAtOffset(0,0,NumofBombs.class);
        if(NumBombs!=null){
            if(maxBombs<5){
                maxBombs++;
            }
            getWorld().removeObject(NumBombs);
        }
        Actor Power = getOneObjectAtOffset(0,0,Power.class);
        if(Power!=null){
            if(power<5){
                power++;
            }
            getWorld().removeObject(Power);
        }
        Actor Life = getOneObjectAtOffset(0,0,Life.class);
        if(Life!=null){
            BombermanWorld world = (BombermanWorld) getWorld();
            world.addLife(2);
            getWorld().removeObject(Life);
        }
    }
    /**
     * Reduces stats and makes player blink when hit
     */
    public void hit()
    {
        power = 1;
        maxBombs = 1;
        speed = 1;
        blink = true;
    }
    /**
     * Sends user data to world
     */
    public void sendUserData()
    {
        BombermanWorld world = (BombermanWorld) getWorld();
        world.storePlayerData(2, speed, maxBombs, power);
    }
}
