import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
/**
 * Write a description of class Explosion here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Explosion extends Actor
{
    int explosionLength = 25;
    boolean isExploded = false;
    /**
     * Reduces explosion timer and removes the explosion when it is 0
     */
    public void act()
    {
        if(explosionLength > 0){
            if(explosionLength == 25){
                setImage("Flame_1.png");
            }
            if(explosionLength == 15){
                setImage("Flame_3.png");
            }
            if(explosionLength == 5){
                setImage("Flame_5.png");
            }
            explosionLength--;
            detectObjects();
        }
        else{
            getWorld().removeObject(this);
        }
    }
    /**
     * Removes blocks that exploison touches and reduces player life if hit
     */
    public void detectObjects()
    {
        Actor block = getOneObjectAtOffset(0, 0, Block.class);
        Actor player1 = getOneIntersectingObject(Player_1.class);
        Actor player2 = getOneIntersectingObject(Player_2.class);
        if(block != null) 
        {
            getWorld().removeObject(block);
            //mit einer Wahrscheinlichkeit von 40% hinterlässt die Kiste ein Upgrade. Lenni
            if (Greenfoot.getRandomNumber(100) < 40)
            {
                //dann wird zufällig ausgesucht, welches Upgrade abgelegt wird. Lenni
                int u = Greenfoot.getRandomNumber(4);
                if (u == 2)
                {
                    Speed speed = new Speed();
                    getWorld().addObject(speed, getX(), getY()); 
                }   
                else if (u == 1)
                {
                    Power power = new Power();
                    getWorld().addObject(power, getX(), getY()); 
                }
                else if (u == 0)
                {
                    NumofBombs numOfBombs = new NumofBombs();
                    getWorld().addObject(numOfBombs, getX(), getY()); 
                }
                else if (u == 3)
                {
                    Life life = new Life();
                    getWorld().addObject(life, getX(), getY());
                }
            }
        }
        if(player1 !=null){
            BombermanWorld world = (BombermanWorld) getWorld();
            world.reduceLife(1);
        }
        if(player2 !=null){
            BombermanWorld world = (BombermanWorld) getWorld();
            world.reduceLife(2);
        }
    }
}